<!DOCTYPE html>
<html>
<head>
<meta charset='utf-8' />
<link href='./stylesheets/fullcalendar.min.css' rel='stylesheet' />
<link href='./stylesheets/fullcalendar.print.min.css' rel='stylesheet' media='print' />
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/css/bootstrap.min.css" integrity="sha384-WskhaSGFgHYWDcbwN70/dfYBj47jz9qbsMId/iRN3ewGhXQFZCSftd1LZCfmhktB" crossorigin="anonymous">
<style>

  body {
    margin: 40px 10px;
    padding: 0;
    font-family: "Lucida Grande",Helvetica,Arial,Verdana,sans-serif;
    font-size: 14px;
  }

  #calendar {
    max-width: 900px;
    margin: 0 auto;
  }

  .event-hosts {
    color: #90949c;
    font-size: 10px;
  }
  .event-sharer {
    color: #90949c;
    font-size: 10px;
  }
</style>
</head>
<body>

  <div id='calendar'></div>

  <!-- Modal -->
  <div class="modal fade" id="filteringModal" tabindex="-1" role="dialog" aria-labelledby="dialogFilteringHeader" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="dialogFilteringHeader">Options de filtrage</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          Afficher les événements partagés par :
          <form id="filteringForm">
          </form>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-primary" data-dismiss="modal">Fermer</button>
        </div>
      </div>
    </div>
  </div>

  <script src='./javascripts/lib/moment.min.js'></script>
  <script src='./javascripts/lib/jquery.min.js'></script>
  <script src="./javascripts/lib/he.js"></script>
  <script src='./javascripts/fullcalendar.min.js'></script>
  <script src='./javascripts/locales/fr.js'></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js" integrity="sha384-smHYKdLADwkXOn1EmN1qk/HfnUcbVRZyYmZ4qpPea6sjB/pTJ0euyQp0Mk8ck+5T" crossorigin="anonymous"></script>

  <script>
    $(document).ready(function() {
      var allSharerFiltering = null;
      var enabledSharerFiltering = null;
      var allEvents = null;

      function getSharersFromEvents(events) {
        var reduceEventSharer = function(accumulator, currentFbPage) {
          if (accumulator.includes(currentFbPage.title)) {
            return accumulator;
          }
          return accumulator.concat([currentFbPage.title]);
        };
        var reduceEventsSharers = function(accumulator, currentEvent) {
          return currentEvent.fbPages.reduce(reduceEventSharer, accumulator);
        };
        return events.reduce(reduceEventsSharers, []);
      }

      function filterEvents() {
        var filter = [];
        $('.filteringCheckbox:checked').each(function(k, sharerElement){
          filter.push(sharerElement.value);
        });

        var toDisplay = [];

        allEvents.map(function(event) {
          var mustDisplay = event.fbPages.some(function(sharer) {
            return filter.includes(he.decode(sharer.title));
          });

          if (mustDisplay) {
            toDisplay.push(event);
          }
        });

        return toDisplay;
      }

      function displaySharersFiltering() {
        var filteringForm = $('#filteringForm');
        allSharerFiltering.sort().forEach(function(sharer) {
          filteringForm.append(
            '<div class="custom-control custom-checkbox">' +
              '<input type="checkbox" class="custom-control-input filteringCheckbox" ' +
                'id="filtering-' + sharer + '" ' +
                'value="' + sharer + '"' +
                (enabledSharerFiltering.includes(sharer) ? 'checked' : '') +
              '>' +
              '<label class="custom-control-label" for="filtering-' + sharer + '">' + sharer + '</label>' +
            '</div>'
          );
        });

        $('.filteringCheckbox').click(function(){
          $('#calendar').fullCalendar('removeEvents');
          $('#calendar').fullCalendar('renderEvents', filterEvents());
        });
      }

      $('#calendar').fullCalendar({
        header: {
          left: 'prev,next today filtering',
          center: 'title',
          right: 'month,agendaWeek,listWeek'
        },
        navLinks: true, // can click day/week names to navigate views
        editable: false,
        eventLimit: true, // allow "more" link when too many events
        events: function(start, end, timezone, callback) {
          $.ajax({
            url: './events.json',
            dataType: 'json',
            success: function(events) {
              if (allEvents === null) {
                allEvents = events;
              }
              if (allSharerFiltering === null) {
                allSharerFiltering = getSharersFromEvents(events);
                enabledSharerFiltering = allSharerFiltering;
                displaySharersFiltering();
              }

              callback(filterEvents());
            }
          });
        },
        locale: 'fr',
        timezone: 'local',
        customButtons: {
          filtering: {
            text: 'Options de filtrage',
            click: function() {
              $('#filteringModal').modal();
            }
          }
        },
        eventClick: function(event) {

          var sharer = event.fbPages ? event.fbPages.map(function (fbPage) {
            return fbPage.title;
          }) : [];

          var content =
            '<div class="event-hosts">Organisé par : ' +
            event.hosts.join(', ') +
            '</div><div class="event-sharer">Partagé par : ' +
            sharer.join(', ') +
            '</div><div class="event-description">' +
            event.description +
            '</div>' +
            '<a href="' + event.url + '" target="_blank">En savoir plus</a>';

          $(this).popover({
            title: event.title,
            content: content,
            html: true,
            trigger: 'focus'
          }).popover('toggle');
          return false;
        }
      });

    });
  </script>
</body>
</html>
